@echo off
cls

rem ----------------------------------------------------
rem --           ici dfinir les variables :          --
rem ----------------------------------------------------

rem -- dossier ou se trouve nconvert.exe. attention pour vista et seven --
rem set Dirnconvert="C:\Program Files\XnView\nconvert.exe"
set Dirnconvert="C:\Program Files (x86)\XnView\nconvert.exe"

rem -- extension des fichiers. exemple : *.jpg ou *.* pour tous --
set in=*.jpg *.jpe *.gif *.bmp *.png *.tif *.tiff

rem -- dossier de sortie se trouvant dans le mme rpertoire que le dossier ou les fichiers envoy(s) en entre --
rem --  tester : pouvoir remonter dans le dossier parent et plus. ou pas. --
set dest=convertis

rem -- cette variable est juste l pour indiquer si on travaille avec des fichiers ou un rpertoire --
set i=two

rem -- options de traitement et de redimensionnement communes --
rem -- l'option "-jpegtrans exif" bypass tout le reste (quand l'image est dj bien oriente en tout cas) ! --
rem -- Du coup rien n'est trait. Cette option doit donc tre dsactiv et l'orientation gre  part (voir plus bas) --
set OPT=-opthuff -i -rflag decr -rexifthumb -keep_icc -keepcspace -rtype lanczos -ratio -dct 2 -subsampling 2 -32bits -quiet

set CONV1=%Dirnconvert% -q 80 %OPT% -resize 800 800 -rmeta -out jpeg -o %dest%\%%.jpg
set CONV2=%Dirnconvert% -q 80 %OPT% -resize 128 128 -rmeta -out jpeg -o %dest%\thumbnail\TN-%%.jpg
set CONV3=%Dirnconvert% -q 95 %OPT% -out jpeg -o %dest%\pwg_high\%%.jpg

rem ----------------------------------------------------
rem --          traitement des rpertoires:           --
rem ----------------------------------------------------

rem --  la meilleure technique que j'ai trouv pour vrifier si il s'agit d'un rpertoire  --
rem --  litralement : si le premier lment de la liste ne contient rien ou contient n'importe quoi alors ...  -- 
rem --  On en dduit que c'est un "contenant" donc un rpertoir  --
if exist %1\nul set i=one
if exist %1\* set i=one
rem -- place l'"action" dans le rpertoire des images --
if %i%==1 (cd /d %1) else (cd /d %~dp1)

md %dest%
md %dest%\thumbnail
md %dest%\pwg_high


if %i%==one (
echo rpertoire : %1
set entre=%1\%in%
) else (
echo liste : %*
set entre=%*
)
echo.
call :traitement %entre%
goto :eof

echo.

rem --------------------------------------------------
rem --          traitement des fichiers :           --
rem --------------------------------------------------
:traitement
@SETLOCAL ENABLEDELAYEDEXPANSION
@IF ERRORLEVEL 1 echo Unable to enable extensions

rem @echo.
rem @echo conversion d'une selection de fichiers
@echo liste : !entre!
@echo.


rem -- Boucle fichiers --
@for %%Z in (%entre%) do (
@echo                     -      -*-      -*-      -*-      -
@echo traitement de %%Z

@set W=
@set H=
@set W2=
@set H2=
@set info=
@set Y=%%~nxZ

rem -- On enleve les espaces vides dans les noms de fichiers --
@set renam=!Y: =_!
ren "%%~Z" !renam!
@set Y="%%~dpZ!renam!"

@set info=!Dirnconvert! -info !Y!
@rem echo           ------ & @echo !info! : & !info! & echo. & echo           ------ & echo.

rem --          Test prsence fichier           --
rem -- Attention : il n'y a test que de l'image "normal" --
@if NOT EXIST "!dest!\%%~nxZ" (
@echo off
%CONV1% !Y!
%CONV2% !Y!

rem -- traitement des images Hautes Dfinitions, avec gestion des formats atypiques (panorama, carr) --
rem -- un tri est fait en comparant hauteur et largeur, informations tires de "nconvert -info" --
rem -- Aprs divers essais 4 possibilits sont gardes : --
rem -- - format horizontale, montages/panorama ou non --
rem -- - format verticale, montages/panorama ou non --
rem -- les formats plus proche du carr sont pour moi des montages, en fixant leur plus petite dimension --
rem -- et en laissant l'autre "flottante" j'ai globalement plus de "matire" comme pour les panoramas, --
rem -- ce qui est un choix personnel. Ca me semble "universel" nanmoins. --

rem --        extraction des info "width" et "height"        --
for /F "usebackq tokens=1-2 delims=: " %%A in (`@!info!`) do (
if %%A==Width (
set W=%%B
rem echo W=!W!
)
if %%A==Height (
set H=%%B
rem echo H=!H!
)
)

rem -- Tri par comparaison & traitement adapt au ratio width/height --
rem -- J'utilise les dimensions du format maxi, aproximativement 3/2 (ratio=0.67) --
rem -- Attention ! le ratio exact change trs lgrement aprs rduction (ex : thumbnail ratio=0.66) ! --
rem -- D'ou l'utilisation des chiffres 4256 et 2832, qui offre assez de prcision pour tre universels --
@set /A H2=!H!*4256/2832
@set /A W2=!W!*4256/2832

rem -- A savoir : l'utilisation de la division ne donne QUE des chiffres entier -> erreur potentielle ! --
rem -- mon systme de calcul vite donc ce problme, tout en gardant assez de prcision --

rem @echo      -------
if !W! GEQ !H! (
	if !W! GTR !H2! (
		rem echo image horizontale et panoramique, utilisation de la formule "%%CONV2%% -resize 0 851 !Z!"
		%CONV3% -resize 0 851 !Y!
	) else (
		rem echo image horizontale, utilisation de la formule "%%CONV2%% -resize 1280 0 !Z!"
		%CONV3% -resize 1280 0 !Y!
	)
) else (
	if !H! GTR !W2! (
		rem echo image verticale et panoramique, utilisation de la formule "%%CONV2%% -resize 851 0 !Z!"
		%CONV3% -resize 851 0 !Y!
	) else (
		rem echo image verticale, utilisation de la formule "%%CONV2%% -resize 0 1280 !Z!"
		%CONV3% -resize 0 1280 !Y!
	)
)
echo %%~nxZ traite
) else (
echo %%~nxZ existe deja
)
rem echo.
rem --       Fin test prsence fichier       --
)
rem --          Fin boucle fichiers          --
echo fin de traitement
@ENDLOCAL
echo.
echo -------------------------------------------------------------------------
echo.

:end
echo operation terminee :)
dir *.* /s > contenu.txt
pause>nul